function Dfs65001_ParametrosNfse_Controller(ScreenService, templateManager, restEngine, localStorageEngine, General, fileRepository, ZHPromise) {

    var inscUsePhrase = ['4895'];

    var self = this;
    
    this.salvar = function(widget) {
       if (widget.isValid()) {
            if (widget.currentRow.__is_new == true) {
                widget.currentRow.CDSENHACERTDIG_OLD = "";
                widget.currentRow.CDSENHAACESSOWS_OLD = "";
                widget.currentRow.__using_unit = false;
                widget.currentRow.__is_new_code = true;
                widget.currentRow.__new_code_pk = "PARAMNFSEINSCMUNI";
                widget.currentRow.__table_pk = "NRPARAMNFSEINSCMUNI";
                widget.currentRow.__cast_number = true;
                widget.currentRow.__new_code_length = 10;
                widget.currentRow.__columns_to_return = ["NRPARAMNFSEINSCMUNI", "NRORG", "DTINCLUSAO", "CDOPERINCLUSAO", "NRORGINCLUSAO"];
            }

            widget.saveRow().then(function(success) {
                if (success.dataset && success.dataset.columnsToReturn[0]) {
                    widget.currentRow.NRPARAMNFSEINSCMUNI = success.dataset.columnsToReturn[0].NRPARAMNFSEINSCMUNI;
                    widget.currentRow.NRORG               = success.dataset.columnsToReturn[0].NRORG;
                    widget.currentRow.DTINCLUSAO          = success.dataset.columnsToReturn[0].DTINCLUSAO;
                    widget.currentRow.CDOPERINCLUSAO      = success.dataset.columnsToReturn[0].CDOPERINCLUSAO;
                    widget.currentRow.NRORGINCLUSAO       = success.dataset.columnsToReturn[0].NRORGINCLUSAO;

                    if (success.dataset.columnsToReturn[0].CDSENHACERTDIG) {
                        widget.currentRow.CDSENHACERTDIG = success.dataset.columnsToReturn[0].CDSENHACERTDIG;
                    }
                    
                    if (success.dataset.columnsToReturn[0].CDSENHAACESSOWS) {
                        widget.currentRow.CDSENHAACESSOWS = success.dataset.columnsToReturn[0].CDSENHAACESSOWS;
                    }
                    
                }
                
                widget.currentRow.changed = false;
                if (widget.currentRow.__is_new) {
                    widget.currentRow.__is_new = false;
                    widget.view();
                }
                else {
                    widget.view();
                }
                
                this.alternaMaxLength(true);
                this.alteraTemplateFraseSecreta(widget);
                
                General.changeWidgetAcessibility(widget.widgets, true);
                widget.reload();
            }.bind(this),
            function(error) {
                var errorMessage = error;
                if (error.data) {
                    errorMessage = error.data.error;
                }
                ScreenService.showMessage(errorMessage);
            });
        }
    };
    
    this.validaSaas = function(widget) {
        let nrorg = getLocalVar('NRORG');
        if(nrorg == 1) {
            widget.getField('IDLOCALSERVIDOR').dataSource.data = [
                {
                     "VALUE": "1",
                    "NAME": "Local"
                },
                {
                    "VALUE": "2",
                    "NAME": "Teknisa"
                }
            ];
        }
        else {
            widget.getField('IDLOCALSERVIDOR').dataSource.data = [{
                    "VALUE": "2",
                    "NAME": "Teknisa"
            }];
        }
    };
    
    this.editar = function(widget) {
        widget.currentRow.CDSENHACERTDIG_OLD = widget.currentRow.CDSENHACERTDIG;
        widget.currentRow.CDSENHAACESSOWS_OLD = widget.currentRow.CDSENHAACESSOWS;
        
        General.widgetEdit(widget);
        var fieldInscricao = widget.getField("CDINSCMUNI");
        let fieldEmpresa = widget.getField("NMEMPRESA");
        var cdempresa = widget.currentRow.CDEMPRESA;
        
        fieldInscricao.dataSourceFilter[0].value = cdempresa;
        fieldInscricao.readOnly = true;
        fieldEmpresa.readOnlyOnEdit = true;
        
        this.alternaMaxLength(false);
        this.alteraTemplateFraseSecreta(widget);

        fieldInscricao.reload();
        fieldEmpresa.reload();
    };
    
    this.controlaFieldInscMunc = function(fieldEmpresa, fieldInscricao) {
        if(fieldEmpresa.value()) fieldInscricao.readOnly = false;
        else fieldInscricao.readOnly = true;

        fieldInscricao.reload();
    };
    
    this.nmEmpresaOnChange = function(widget) {
        let fieldInscricao = widget.getField("CDINSCMUNI");
        let fieldEmpresa = widget.getField("NMEMPRESA");
        let cdempresa = widget.currentRow.CDEMPRESA;
        
        fieldInscricao.dataSourceFilter[0].value = cdempresa;
        fieldInscricao.clearValue();
        this.controlaFieldInscMunc(fieldEmpresa, fieldInscricao);
    };
    
    this.controlarCaminhoCertificado = function(field) {
        var fieldCaminhoCert = field.widget.getField("DSCAMINHOCERTDIG");
        if (field.value() == "1") {
            fieldCaminhoCert.readOnly = false;
            fieldCaminhoCert.placeholder = "";
        }
        else {
            fieldCaminhoCert.readOnly = true;
            fieldCaminhoCert.placeholder = "Servidor Teknisa";
        }
    };
    
    this.uploadFile = function(widget) {
        var wdgListaCertDig = templateManager.container.getWidget('wdgListaCertDig');
        if(widget.isValid()) {
            if(widget.currentRow.CERTIFICADO.length == 0) {
                ScreenService.showMessage('Adicione o certificado!');
            }
            else if(widget.currentRow.CERTIFICADO.length + wdgListaCertDig.dataSource.data.length > 2) {
                ScreenService.showMessage('Certificado já existe no servidor. Exclua e tente novamente');   
            }
            else {
                if(widget.getParent().currentRow.IDLOCALSERVIDOR === "1") this.uploadFileLocal(widget);
                else this.uploadFileFileServer(widget);
            }
        }
    };
    
    this.uploadFileLocal = function(widget) {
        widget.currentRow.NRPARAMNFSEINSCMUNI = widget.getParent().currentRow.NRPARAMNFSEINSCMUNI;
        widget.currentRow.CDEMPRESA           = widget.getParent().currentRow.CDEMPRESA;
        widget.currentRow.CDINSCMUNI          = widget.getParent().currentRow.CDINSCMUNI;
        widget.currentRow.NRORG               = widget.getParent().currentRow.NRORG;
        
        var dataSource = widget.dataSource;
        dataSource.data = [widget.currentRow];
        General.callRestEngine('df_saida#/saveCertificadoLocal', 'Row', widget.currentRow).then(function() {
            return fileRepository.saveInServer();
        }).then(function(data) {
            var wdgListaCertDig = templateManager.container.getWidget("wdgListaCertDig");
            self.createWidgetDataSource(wdgListaCertDig);
            self.closeAnexoSwipe(widget);
        }, function(error) {
            if(error.data.errorCode == 100) {
                ScreenService.showMessage(error.data.error);
            }
            console.error(error);
        });
    };
    
    this.uploadFileFileServer = function(widget) {
        widget.currentRow.NRPARAMNFSEINSCMUNI = widget.getParent().currentRow.NRPARAMNFSEINSCMUNI;
        widget.currentRow.CDEMPRESA           = widget.getParent().currentRow.CDEMPRESA;
        widget.currentRow.CDINSCMUNI          = widget.getParent().currentRow.CDINSCMUNI;
        widget.currentRow.NRORG               = widget.getParent().currentRow.NRORG;
        widget.currentRow.CDSENHACERTDIG      = widget.getParent().getParent().currentRow.CDSENHACERTDIG;

        var row = widget.currentRow;
        General.callRestEngine('df_saida#/saveCerticadoFileServer', 'Row', row).then(function() {
            var wdgListaCertDig = templateManager.container.getWidget("wdgListaCertDig");
            self.createWidgetDataSource(wdgListaCertDig);
            self.closeAnexoSwipe(widget);
        }, function(error) {
            if(error.data.errorCode == 101) {
             ScreenService.showMessage(error.data.error);
            }
        });
    };
    
    this.createWidgetDataSource = function(widget) {
        var nrparamnfseinscmuni = widget.getParent().currentRow.NRPARAMNFSEINSCMUNI;
        var cdempresa           = widget.getParent().currentRow.CDEMPRESA;
        var cdinscmuni          = widget.getParent().currentRow.CDINSCMUNI;
        var nrorg               = widget.getParent().currentRow.NRORG;
        var idlocalservidor     = widget.getParent().currentRow.IDLOCALSERVIDOR;
        
        widget.currentRow.NRPARAMNFSEINSCMUNI = nrparamnfseinscmuni;
        widget.currentRow.CDEMPRESA           = cdempresa;
        widget.currentRow.CDINSCMUNI          = cdinscmuni;
        widget.currentRow.NRORG               = nrorg;
        widget.currentRow.IDLOCALSERVIDOR     = idlocalservidor;
        
        var params = {
            "NRPARAMNFSEINSCMUNI": nrparamnfseinscmuni,
            "CDEMPRESA"          : cdempresa,
            "CDINSCMUNI"         : cdinscmuni,
            "IDLOCALSERVIDOR"    : idlocalservidor,
            "NRORG"              : nrorg
        };

        General.callRestEngine("df_saida#/paramnfse_certDig/createFileDataSet", "Row", params).then(function(success) {
            localStorageEngine.remove("df_saida#/paramnfse_certDig", "").then(function()
            {
                localStorageEngine.save("df_saida#/paramnfse_certDig", success.dataset.paramnfse_certDig).then(function()
                {
                    var widget = templateManager.container.getWidget("wdgListaCertDig");
                    widget.reload();
                });
            });
        },
        function(error) {
            console.error(error);
            ScreenService.showMessage(error.data.error);
        });
    };
    
    this.downloadFile = function(widget) {
        var body = document.body;
    
        this.downloadFilePromisse(widget, body).then((element) => {
            body.removeChild(element);
        });
        
    };
    
    this.downloadFilePromisse = function(widget, body) {
        var deferred = ZHPromise.defer();
       
        var element = document.createElement("a");
    
    
        element.href = widget.currentRow.path; 
    
        element.download = widget.currentRow.fileName;
        
        element.className = "hide-link";
    
        body.appendChild(element);
    
        if (element.fireEvent) {
            element.fireEvent("onclick");
        } else {
            var evObj = document.createEvent("MouseEvents");
            evObj.initEvent("click", true, false);
            element.dispatchEvent(evObj);
        }
        deferred.resolve(element);
        return deferred;
    };
    
    this.openAnexoSwipe = function(widget) {
        if(!widget.getParent().getParent().currentRow.CDSENHACERTDIG) {
            ScreenService.showMessage('Informe a senha do certificado antes de adicionar!');
        } else {
            widget.isVisible = true;
            ScreenService.openSwipe(widget).then(function(){
                widget.newRow();
            });
        }
    };
    
    this.closeAnexoSwipe = function(widget) {
        widget.dataSource.data.pop();
        ScreenService.closeSwipe();
        widget.isVisible = false;
    };
    
    this.excluiReg = function(args) {
        var widget = args.owner.widget;
        ScreenService.confirmMessage("Excluir Registro?", "question", function() {
            General.callRestEngine('df_saida#/paramnfseinscmuni/remove','Row', widget.currentRow).then(function() {
                ScreenService.closeSwipe();
                widget.reload();
            },function(error) {
                console.error(error);
                ScreenService.showMessage(error.data.error);
            });
        });
    };
    
    this.deleteFile = function(widget) {
        var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
        widget.currentRow.IDLOCALSERVIDOR = widget.getParent().currentRow.IDLOCALSERVIDOR;
		var row = Util.clone(widget.currentRow, ignoredKeys);
		
        ScreenService.confirmMessage("Excluir Anexo?", "question", function() {
            restEngine.post('df_saida#/paramnfse_certDig/deleteFile',
            {
                "requestType": "Row",
                "row": row
            }, function(success)
            {
                var wdgListaCertDig = templateManager.container.getWidget('wdgListaCertDig');
                self.createWidgetDataSource(wdgListaCertDig);
                ScreenService.closeSwipe();
                ScreenService.showMessage("Anexo excluído.");
            }, undefined, function(error)
            {
                console.log(error);
            });
        }, null);
    };
    
    /** 
     * A função altera o template do campo CDFRASESECRETA, caso esteja sendo inserido um valor, ou seja, 
     * na adição ou ao editar e o valor deste seja nulo.
     * neste campo o template alterna para text, para facilitar a visualização. Caso contrário,
    ** assume o template password.
    */
    
    this.alteraTemplateFraseSecreta = function(widget) {
        var fieldFraseSecreta = widget.getField('CDFRASESECRETA');
        
        if((fieldFraseSecreta.value() == null || fieldFraseSecreta.value() == "") && widget.editing) {
            fieldFraseSecreta.template = "field/text-edit.html";        
        } else {
            fieldFraseSecreta.template = "field/password-edit.html";        
        }
        fieldFraseSecreta.reload();
    };
    /**
     * A função tem por condição acionar as ações de cancelar, voltar e salvar como verdadeiro
     * e falso quando acionar as ações de editar e adicionar. É necessária a alteração devido
     * a diferença entre o tamanho permitido da frase e o valor da frase criptografada
     * 
    */
    
    this.alternaMaxLength = function(condicao) {
        var widget = templateManager.container.getWidget('wdgParametrosNfseInscmuni');
        var fieldFraseSecreta = widget.getField('CDFRASESECRETA');
        
        if(condicao) {
            fieldFraseSecreta.maxlength = 100;
        } else {
            fieldFraseSecreta.maxlength = 20;
        }
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register("Dfs65001_ParametrosNfse_Controller", Dfs65001_ParametrosNfse_Controller);
});
